// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from lex_common_msgs:srv/AudioTextConversation.idl
// generated code does not contain a copyright notice

#ifndef LEX_COMMON_MSGS__SRV__AUDIO_TEXT_CONVERSATION__FUNCTIONS_H_
#define LEX_COMMON_MSGS__SRV__AUDIO_TEXT_CONVERSATION__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_generator_c/visibility_control.h"
#include "lex_common_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "lex_common_msgs/srv/audio_text_conversation__struct.h"

/// Initialize srv/AudioTextConversation message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * lex_common_msgs__srv__AudioTextConversation_Request
 * )) before or use
 * lex_common_msgs__srv__AudioTextConversation_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
bool
lex_common_msgs__srv__AudioTextConversation_Request__init(lex_common_msgs__srv__AudioTextConversation_Request * msg);

/// Finalize srv/AudioTextConversation message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
void
lex_common_msgs__srv__AudioTextConversation_Request__fini(lex_common_msgs__srv__AudioTextConversation_Request * msg);

/// Create srv/AudioTextConversation message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * lex_common_msgs__srv__AudioTextConversation_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
lex_common_msgs__srv__AudioTextConversation_Request *
lex_common_msgs__srv__AudioTextConversation_Request__create();

/// Destroy srv/AudioTextConversation message.
/**
 * It calls
 * lex_common_msgs__srv__AudioTextConversation_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
void
lex_common_msgs__srv__AudioTextConversation_Request__destroy(lex_common_msgs__srv__AudioTextConversation_Request * msg);


/// Initialize array of srv/AudioTextConversation messages.
/**
 * It allocates the memory for the number of elements and calls
 * lex_common_msgs__srv__AudioTextConversation_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
bool
lex_common_msgs__srv__AudioTextConversation_Request__Sequence__init(lex_common_msgs__srv__AudioTextConversation_Request__Sequence * array, size_t size);

/// Finalize array of srv/AudioTextConversation messages.
/**
 * It calls
 * lex_common_msgs__srv__AudioTextConversation_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
void
lex_common_msgs__srv__AudioTextConversation_Request__Sequence__fini(lex_common_msgs__srv__AudioTextConversation_Request__Sequence * array);

/// Create array of srv/AudioTextConversation messages.
/**
 * It allocates the memory for the array and calls
 * lex_common_msgs__srv__AudioTextConversation_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
lex_common_msgs__srv__AudioTextConversation_Request__Sequence *
lex_common_msgs__srv__AudioTextConversation_Request__Sequence__create(size_t size);

/// Destroy array of srv/AudioTextConversation messages.
/**
 * It calls
 * lex_common_msgs__srv__AudioTextConversation_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
void
lex_common_msgs__srv__AudioTextConversation_Request__Sequence__destroy(lex_common_msgs__srv__AudioTextConversation_Request__Sequence * array);

/// Initialize srv/AudioTextConversation message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * lex_common_msgs__srv__AudioTextConversation_Response
 * )) before or use
 * lex_common_msgs__srv__AudioTextConversation_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
bool
lex_common_msgs__srv__AudioTextConversation_Response__init(lex_common_msgs__srv__AudioTextConversation_Response * msg);

/// Finalize srv/AudioTextConversation message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
void
lex_common_msgs__srv__AudioTextConversation_Response__fini(lex_common_msgs__srv__AudioTextConversation_Response * msg);

/// Create srv/AudioTextConversation message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * lex_common_msgs__srv__AudioTextConversation_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
lex_common_msgs__srv__AudioTextConversation_Response *
lex_common_msgs__srv__AudioTextConversation_Response__create();

/// Destroy srv/AudioTextConversation message.
/**
 * It calls
 * lex_common_msgs__srv__AudioTextConversation_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
void
lex_common_msgs__srv__AudioTextConversation_Response__destroy(lex_common_msgs__srv__AudioTextConversation_Response * msg);


/// Initialize array of srv/AudioTextConversation messages.
/**
 * It allocates the memory for the number of elements and calls
 * lex_common_msgs__srv__AudioTextConversation_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
bool
lex_common_msgs__srv__AudioTextConversation_Response__Sequence__init(lex_common_msgs__srv__AudioTextConversation_Response__Sequence * array, size_t size);

/// Finalize array of srv/AudioTextConversation messages.
/**
 * It calls
 * lex_common_msgs__srv__AudioTextConversation_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
void
lex_common_msgs__srv__AudioTextConversation_Response__Sequence__fini(lex_common_msgs__srv__AudioTextConversation_Response__Sequence * array);

/// Create array of srv/AudioTextConversation messages.
/**
 * It allocates the memory for the array and calls
 * lex_common_msgs__srv__AudioTextConversation_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
lex_common_msgs__srv__AudioTextConversation_Response__Sequence *
lex_common_msgs__srv__AudioTextConversation_Response__Sequence__create(size_t size);

/// Destroy array of srv/AudioTextConversation messages.
/**
 * It calls
 * lex_common_msgs__srv__AudioTextConversation_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_lex_common_msgs
void
lex_common_msgs__srv__AudioTextConversation_Response__Sequence__destroy(lex_common_msgs__srv__AudioTextConversation_Response__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // LEX_COMMON_MSGS__SRV__AUDIO_TEXT_CONVERSATION__FUNCTIONS_H_
