#ifndef H_10031067CD98DD1544817328E1B6273B_AudioTextConversation_SPLTYPES_H
#define H_10031067CD98DD1544817328E1B6273B_AudioTextConversation_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_AudioTextConversation_.h"
#include "lex_common_msgs/msg/dds_opensplice/KeyValue_SplDcps.h"



extern c_metaObject __AudioTextConversation__lex_common_msgs__load (c_base base);

extern c_metaObject __AudioTextConversation__lex_common_msgs_srv__load (c_base base);

extern c_metaObject __AudioTextConversation__lex_common_msgs_srv_dds___load (c_base base);

extern const char *lex_common_msgs_srv_dds__AudioTextConversation_Request__metaDescriptor[];
extern const int lex_common_msgs_srv_dds__AudioTextConversation_Request__metaDescriptorArrLength;
extern const int lex_common_msgs_srv_dds__AudioTextConversation_Request__metaDescriptorLength;
extern c_metaObject __lex_common_msgs_srv_dds__AudioTextConversation_Request___load (c_base base);
struct _lex_common_msgs_srv_dds__AudioTextConversation_Request_ ;
extern  v_copyin_result __lex_common_msgs_srv_dds__AudioTextConversation_Request___copyIn(c_base base, const struct lex_common_msgs::srv::dds_::AudioTextConversation_Request_ *from, struct _lex_common_msgs_srv_dds__AudioTextConversation_Request_ *to);
extern  void __lex_common_msgs_srv_dds__AudioTextConversation_Request___copyOut(const void *_from, void *_to);
struct _lex_common_msgs_srv_dds__AudioTextConversation_Request_ {
    c_string content_type_;
    c_string accept_type_;
    c_string text_request_;
    c_sequence audio_request_;
};

extern const char *lex_common_msgs_srv_dds__AudioTextConversation_Response__metaDescriptor[];
extern const int lex_common_msgs_srv_dds__AudioTextConversation_Response__metaDescriptorArrLength;
extern const int lex_common_msgs_srv_dds__AudioTextConversation_Response__metaDescriptorLength;
extern c_metaObject __lex_common_msgs_srv_dds__AudioTextConversation_Response___load (c_base base);
struct _lex_common_msgs_srv_dds__AudioTextConversation_Response_ ;
extern  v_copyin_result __lex_common_msgs_srv_dds__AudioTextConversation_Response___copyIn(c_base base, const struct lex_common_msgs::srv::dds_::AudioTextConversation_Response_ *from, struct _lex_common_msgs_srv_dds__AudioTextConversation_Response_ *to);
extern  void __lex_common_msgs_srv_dds__AudioTextConversation_Response___copyOut(const void *_from, void *_to);
struct _lex_common_msgs_srv_dds__AudioTextConversation_Response_ {
    c_string text_response_;
    c_sequence audio_response_;
    c_sequence slots_;
    c_string intent_name_;
    c_string message_format_type_;
    c_string dialog_state_;
    c_octet error_code_;
    c_string error_message_;
};

extern const char *lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request__metaDescriptor[];
extern const int lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request__metaDescriptorArrLength;
extern const int lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request__metaDescriptorLength;
extern c_metaObject __lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request___load (c_base base);
struct _lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request_ ;
extern  v_copyin_result __lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request___copyIn(c_base base, const struct lex_common_msgs::srv::dds_::Sample_AudioTextConversation_Request_ *from, struct _lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request_ *to);
extern  void __lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request___copyOut(const void *_from, void *_to);
struct _lex_common_msgs_srv_dds__Sample_AudioTextConversation_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _lex_common_msgs_srv_dds__AudioTextConversation_Request_ request_;
};

extern const char *lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response__metaDescriptor[];
extern const int lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response__metaDescriptorArrLength;
extern const int lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response__metaDescriptorLength;
extern c_metaObject __lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response___load (c_base base);
struct _lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response_ ;
extern  v_copyin_result __lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response___copyIn(c_base base, const struct lex_common_msgs::srv::dds_::Sample_AudioTextConversation_Response_ *from, struct _lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response_ *to);
extern  void __lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response___copyOut(const void *_from, void *_to);
struct _lex_common_msgs_srv_dds__Sample_AudioTextConversation_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _lex_common_msgs_srv_dds__AudioTextConversation_Response_ response_;
};

#undef OS_API
#endif
