// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from lex_common_msgs:srv/AudioTextConversation.idl
// generated code does not contain a copyright notice
#include "lex_common_msgs/srv/audio_text_conversation__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

// Include directives for member types
// Member `content_type`
// Member `accept_type`
// Member `text_request`
#include "rosidl_generator_c/string_functions.h"
// Member `audio_request`
#include "rosidl_generator_c/primitives_sequence_functions.h"

bool
lex_common_msgs__srv__AudioTextConversation_Request__init(lex_common_msgs__srv__AudioTextConversation_Request * msg)
{
  if (!msg) {
    return false;
  }
  // content_type
  if (!rosidl_generator_c__String__init(&msg->content_type)) {
    lex_common_msgs__srv__AudioTextConversation_Request__destroy(msg);
    return false;
  }
  // accept_type
  if (!rosidl_generator_c__String__init(&msg->accept_type)) {
    lex_common_msgs__srv__AudioTextConversation_Request__destroy(msg);
    return false;
  }
  // text_request
  if (!rosidl_generator_c__String__init(&msg->text_request)) {
    lex_common_msgs__srv__AudioTextConversation_Request__destroy(msg);
    return false;
  }
  // audio_request
  if (!rosidl_generator_c__uint8__Sequence__init(&msg->audio_request, 0)) {
    lex_common_msgs__srv__AudioTextConversation_Request__destroy(msg);
    return false;
  }
  return true;
}

void
lex_common_msgs__srv__AudioTextConversation_Request__fini(lex_common_msgs__srv__AudioTextConversation_Request * msg)
{
  if (!msg) {
    return;
  }
  // content_type
  rosidl_generator_c__String__fini(&msg->content_type);
  // accept_type
  rosidl_generator_c__String__fini(&msg->accept_type);
  // text_request
  rosidl_generator_c__String__fini(&msg->text_request);
  // audio_request
  rosidl_generator_c__uint8__Sequence__fini(&msg->audio_request);
}

lex_common_msgs__srv__AudioTextConversation_Request *
lex_common_msgs__srv__AudioTextConversation_Request__create()
{
  lex_common_msgs__srv__AudioTextConversation_Request * msg = (lex_common_msgs__srv__AudioTextConversation_Request *)malloc(sizeof(lex_common_msgs__srv__AudioTextConversation_Request));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(lex_common_msgs__srv__AudioTextConversation_Request));
  bool success = lex_common_msgs__srv__AudioTextConversation_Request__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
lex_common_msgs__srv__AudioTextConversation_Request__destroy(lex_common_msgs__srv__AudioTextConversation_Request * msg)
{
  if (msg) {
    lex_common_msgs__srv__AudioTextConversation_Request__fini(msg);
  }
  free(msg);
}


bool
lex_common_msgs__srv__AudioTextConversation_Request__Sequence__init(lex_common_msgs__srv__AudioTextConversation_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  lex_common_msgs__srv__AudioTextConversation_Request * data = NULL;
  if (size) {
    data = (lex_common_msgs__srv__AudioTextConversation_Request *)calloc(size, sizeof(lex_common_msgs__srv__AudioTextConversation_Request));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = lex_common_msgs__srv__AudioTextConversation_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        lex_common_msgs__srv__AudioTextConversation_Request__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
lex_common_msgs__srv__AudioTextConversation_Request__Sequence__fini(lex_common_msgs__srv__AudioTextConversation_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      lex_common_msgs__srv__AudioTextConversation_Request__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

lex_common_msgs__srv__AudioTextConversation_Request__Sequence *
lex_common_msgs__srv__AudioTextConversation_Request__Sequence__create(size_t size)
{
  lex_common_msgs__srv__AudioTextConversation_Request__Sequence * array = (lex_common_msgs__srv__AudioTextConversation_Request__Sequence *)malloc(sizeof(lex_common_msgs__srv__AudioTextConversation_Request__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = lex_common_msgs__srv__AudioTextConversation_Request__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
lex_common_msgs__srv__AudioTextConversation_Request__Sequence__destroy(lex_common_msgs__srv__AudioTextConversation_Request__Sequence * array)
{
  if (array) {
    lex_common_msgs__srv__AudioTextConversation_Request__Sequence__fini(array);
  }
  free(array);
}


// Include directives for member types
// Member `text_response`
// Member `intent_name`
// Member `message_format_type`
// Member `dialog_state`
// Member `error_message`
// already included above
// #include "rosidl_generator_c/string_functions.h"
// Member `audio_response`
// already included above
// #include "rosidl_generator_c/primitives_sequence_functions.h"
// Member `slots`
#include "lex_common_msgs/msg/key_value__functions.h"

bool
lex_common_msgs__srv__AudioTextConversation_Response__init(lex_common_msgs__srv__AudioTextConversation_Response * msg)
{
  if (!msg) {
    return false;
  }
  // text_response
  if (!rosidl_generator_c__String__init(&msg->text_response)) {
    lex_common_msgs__srv__AudioTextConversation_Response__destroy(msg);
    return false;
  }
  // audio_response
  if (!rosidl_generator_c__uint8__Sequence__init(&msg->audio_response, 0)) {
    lex_common_msgs__srv__AudioTextConversation_Response__destroy(msg);
    return false;
  }
  // slots
  if (!lex_common_msgs__msg__KeyValue__Sequence__init(&msg->slots, 0)) {
    lex_common_msgs__srv__AudioTextConversation_Response__destroy(msg);
    return false;
  }
  // intent_name
  if (!rosidl_generator_c__String__init(&msg->intent_name)) {
    lex_common_msgs__srv__AudioTextConversation_Response__destroy(msg);
    return false;
  }
  // message_format_type
  if (!rosidl_generator_c__String__init(&msg->message_format_type)) {
    lex_common_msgs__srv__AudioTextConversation_Response__destroy(msg);
    return false;
  }
  // dialog_state
  if (!rosidl_generator_c__String__init(&msg->dialog_state)) {
    lex_common_msgs__srv__AudioTextConversation_Response__destroy(msg);
    return false;
  }
  // error_code
  // error_message
  if (!rosidl_generator_c__String__init(&msg->error_message)) {
    lex_common_msgs__srv__AudioTextConversation_Response__destroy(msg);
    return false;
  }
  return true;
}

void
lex_common_msgs__srv__AudioTextConversation_Response__fini(lex_common_msgs__srv__AudioTextConversation_Response * msg)
{
  if (!msg) {
    return;
  }
  // text_response
  rosidl_generator_c__String__fini(&msg->text_response);
  // audio_response
  rosidl_generator_c__uint8__Sequence__fini(&msg->audio_response);
  // slots
  lex_common_msgs__msg__KeyValue__Sequence__fini(&msg->slots);
  // intent_name
  rosidl_generator_c__String__fini(&msg->intent_name);
  // message_format_type
  rosidl_generator_c__String__fini(&msg->message_format_type);
  // dialog_state
  rosidl_generator_c__String__fini(&msg->dialog_state);
  // error_code
  // error_message
  rosidl_generator_c__String__fini(&msg->error_message);
}

lex_common_msgs__srv__AudioTextConversation_Response *
lex_common_msgs__srv__AudioTextConversation_Response__create()
{
  lex_common_msgs__srv__AudioTextConversation_Response * msg = (lex_common_msgs__srv__AudioTextConversation_Response *)malloc(sizeof(lex_common_msgs__srv__AudioTextConversation_Response));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(lex_common_msgs__srv__AudioTextConversation_Response));
  bool success = lex_common_msgs__srv__AudioTextConversation_Response__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
lex_common_msgs__srv__AudioTextConversation_Response__destroy(lex_common_msgs__srv__AudioTextConversation_Response * msg)
{
  if (msg) {
    lex_common_msgs__srv__AudioTextConversation_Response__fini(msg);
  }
  free(msg);
}


bool
lex_common_msgs__srv__AudioTextConversation_Response__Sequence__init(lex_common_msgs__srv__AudioTextConversation_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  lex_common_msgs__srv__AudioTextConversation_Response * data = NULL;
  if (size) {
    data = (lex_common_msgs__srv__AudioTextConversation_Response *)calloc(size, sizeof(lex_common_msgs__srv__AudioTextConversation_Response));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = lex_common_msgs__srv__AudioTextConversation_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        lex_common_msgs__srv__AudioTextConversation_Response__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
lex_common_msgs__srv__AudioTextConversation_Response__Sequence__fini(lex_common_msgs__srv__AudioTextConversation_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      lex_common_msgs__srv__AudioTextConversation_Response__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

lex_common_msgs__srv__AudioTextConversation_Response__Sequence *
lex_common_msgs__srv__AudioTextConversation_Response__Sequence__create(size_t size)
{
  lex_common_msgs__srv__AudioTextConversation_Response__Sequence * array = (lex_common_msgs__srv__AudioTextConversation_Response__Sequence *)malloc(sizeof(lex_common_msgs__srv__AudioTextConversation_Response__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = lex_common_msgs__srv__AudioTextConversation_Response__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
lex_common_msgs__srv__AudioTextConversation_Response__Sequence__destroy(lex_common_msgs__srv__AudioTextConversation_Response__Sequence * array)
{
  if (array) {
    lex_common_msgs__srv__AudioTextConversation_Response__Sequence__fini(array);
  }
  free(array);
}
