#ifndef _H_10031067CD98DD1544817328E1B6273B_AudioTextConversation__H_
#define _H_10031067CD98DD1544817328E1B6273B_AudioTextConversation__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "lex_common_msgs/msg/dds_opensplice/KeyValue_.h"


namespace lex_common_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  AudioTextConversation_Request_
            {
                struct _audio_request__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Octet, struct _audio_request__seq_uniq_ > _audio_request__seq;
                typedef DDS_DCPSSequence_var< _audio_request__seq > _audio_request__seq_var;
                typedef DDS_DCPSSequence_out< _audio_request__seq > _audio_request__seq_out;
                ::DDS::String_mgr content_type_;
                ::DDS::String_mgr accept_type_;
                ::DDS::String_mgr text_request_;
                _audio_request__seq audio_request_;
            };

            typedef DDS_DCPSStruct_var<AudioTextConversation_Request_> AudioTextConversation_Request__var;
            typedef DDS_DCPSStruct_out < AudioTextConversation_Request_> AudioTextConversation_Request__out;

            struct  AudioTextConversation_Response_
            {
                struct _audio_response__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Octet, struct _audio_response__seq_uniq_ > _audio_response__seq;
                typedef DDS_DCPSSequence_var< _audio_response__seq > _audio_response__seq_var;
                typedef DDS_DCPSSequence_out< _audio_response__seq > _audio_response__seq_out;
                struct _slots__seq_uniq_{};
                typedef DDS_DCPSUVLSeq< ::lex_common_msgs::msg::dds_::KeyValue_, struct _slots__seq_uniq_ > _slots__seq;
                typedef DDS_DCPSSequence_var< _slots__seq > _slots__seq_var;
                typedef DDS_DCPSSequence_out< _slots__seq > _slots__seq_out;
                ::DDS::String_mgr text_response_;
                _audio_response__seq audio_response_;
                _slots__seq slots_;
                ::DDS::String_mgr intent_name_;
                ::DDS::String_mgr message_format_type_;
                ::DDS::String_mgr dialog_state_;
                ::DDS::Octet error_code_;
                ::DDS::String_mgr error_message_;
            };

            typedef DDS_DCPSStruct_var<AudioTextConversation_Response_> AudioTextConversation_Response__var;
            typedef DDS_DCPSStruct_out < AudioTextConversation_Response_> AudioTextConversation_Response__out;

            struct  Sample_AudioTextConversation_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::lex_common_msgs::srv::dds_::AudioTextConversation_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AudioTextConversation_Request_> Sample_AudioTextConversation_Request__var;
            typedef DDS_DCPSStruct_out < Sample_AudioTextConversation_Request_> Sample_AudioTextConversation_Request__out;

            struct  Sample_AudioTextConversation_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::lex_common_msgs::srv::dds_::AudioTextConversation_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AudioTextConversation_Response_> Sample_AudioTextConversation_Response__var;
            typedef DDS_DCPSStruct_out < Sample_AudioTextConversation_Response_> Sample_AudioTextConversation_Response__out;

        }

    }

}

#endif /* _H_10031067CD98DD1544817328E1B6273B_AudioTextConversation__H_ */
