#ifndef _H_10031067CD98DD1544817328E1B6273B_AudioTextConversation_DCPS_H_
#define _H_10031067CD98DD1544817328E1B6273B_AudioTextConversation_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AudioTextConversation_.h"


namespace lex_common_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class AudioTextConversation_Request_TypeSupportInterface;

            typedef AudioTextConversation_Request_TypeSupportInterface * AudioTextConversation_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AudioTextConversation_Request_TypeSupportInterface> AudioTextConversation_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AudioTextConversation_Request_TypeSupportInterface> AudioTextConversation_Request_TypeSupportInterface_out;


            class AudioTextConversation_Request_DataWriter;

            typedef AudioTextConversation_Request_DataWriter * AudioTextConversation_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AudioTextConversation_Request_DataWriter> AudioTextConversation_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AudioTextConversation_Request_DataWriter> AudioTextConversation_Request_DataWriter_out;


            class AudioTextConversation_Request_DataReader;

            typedef AudioTextConversation_Request_DataReader * AudioTextConversation_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AudioTextConversation_Request_DataReader> AudioTextConversation_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AudioTextConversation_Request_DataReader> AudioTextConversation_Request_DataReader_out;


            class AudioTextConversation_Request_DataReaderView;

            typedef AudioTextConversation_Request_DataReaderView * AudioTextConversation_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AudioTextConversation_Request_DataReaderView> AudioTextConversation_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AudioTextConversation_Request_DataReaderView> AudioTextConversation_Request_DataReaderView_out;

            struct AudioTextConversation_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AudioTextConversation_Request_, struct AudioTextConversation_Request_Seq_uniq_> AudioTextConversation_Request_Seq;
            typedef DDS_DCPSSequence_var < AudioTextConversation_Request_Seq> AudioTextConversation_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AudioTextConversation_Request_Seq> AudioTextConversation_Request_Seq_out;

            class  AudioTextConversation_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AudioTextConversation_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AudioTextConversation_Request_TypeSupportInterface_var _var_type;

                static AudioTextConversation_Request_TypeSupportInterface_ptr _duplicate (AudioTextConversation_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AudioTextConversation_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AudioTextConversation_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AudioTextConversation_Request_TypeSupportInterface () {};
                ~AudioTextConversation_Request_TypeSupportInterface () {};
            private:
                AudioTextConversation_Request_TypeSupportInterface (const AudioTextConversation_Request_TypeSupportInterface &);
                AudioTextConversation_Request_TypeSupportInterface & operator = (const AudioTextConversation_Request_TypeSupportInterface &);
            };

            class  AudioTextConversation_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AudioTextConversation_Request_DataWriter_ptr _ptr_type;
                typedef AudioTextConversation_Request_DataWriter_var _var_type;

                static AudioTextConversation_Request_DataWriter_ptr _duplicate (AudioTextConversation_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AudioTextConversation_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AudioTextConversation_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AudioTextConversation_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AudioTextConversation_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AudioTextConversation_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AudioTextConversation_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AudioTextConversation_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AudioTextConversation_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AudioTextConversation_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AudioTextConversation_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AudioTextConversation_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AudioTextConversation_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AudioTextConversation_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AudioTextConversation_Request_& instance_data) = 0;

            protected:
                AudioTextConversation_Request_DataWriter () {};
                ~AudioTextConversation_Request_DataWriter () {};
            private:
                AudioTextConversation_Request_DataWriter (const AudioTextConversation_Request_DataWriter &);
                AudioTextConversation_Request_DataWriter & operator = (const AudioTextConversation_Request_DataWriter &);
            };

            class  AudioTextConversation_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AudioTextConversation_Request_DataReader_ptr _ptr_type;
                typedef AudioTextConversation_Request_DataReader_var _var_type;

                static AudioTextConversation_Request_DataReader_ptr _duplicate (AudioTextConversation_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AudioTextConversation_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AudioTextConversation_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AudioTextConversation_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AudioTextConversation_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AudioTextConversation_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AudioTextConversation_Request_& instance) = 0;

            protected:
                AudioTextConversation_Request_DataReader () {};
                ~AudioTextConversation_Request_DataReader () {};
            private:
                AudioTextConversation_Request_DataReader (const AudioTextConversation_Request_DataReader &);
                AudioTextConversation_Request_DataReader & operator = (const AudioTextConversation_Request_DataReader &);
            };

            class  AudioTextConversation_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AudioTextConversation_Request_DataReaderView_ptr _ptr_type;
                typedef AudioTextConversation_Request_DataReaderView_var _var_type;

                static AudioTextConversation_Request_DataReaderView_ptr _duplicate (AudioTextConversation_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AudioTextConversation_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AudioTextConversation_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AudioTextConversation_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AudioTextConversation_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AudioTextConversation_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AudioTextConversation_Request_& instance) = 0;

            protected:
                AudioTextConversation_Request_DataReaderView () {};
                ~AudioTextConversation_Request_DataReaderView () {};
            private:
                AudioTextConversation_Request_DataReaderView (const AudioTextConversation_Request_DataReaderView &);
                AudioTextConversation_Request_DataReaderView & operator = (const AudioTextConversation_Request_DataReaderView &);
            };
            class AudioTextConversation_Response_TypeSupportInterface;

            typedef AudioTextConversation_Response_TypeSupportInterface * AudioTextConversation_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AudioTextConversation_Response_TypeSupportInterface> AudioTextConversation_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AudioTextConversation_Response_TypeSupportInterface> AudioTextConversation_Response_TypeSupportInterface_out;


            class AudioTextConversation_Response_DataWriter;

            typedef AudioTextConversation_Response_DataWriter * AudioTextConversation_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AudioTextConversation_Response_DataWriter> AudioTextConversation_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AudioTextConversation_Response_DataWriter> AudioTextConversation_Response_DataWriter_out;


            class AudioTextConversation_Response_DataReader;

            typedef AudioTextConversation_Response_DataReader * AudioTextConversation_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AudioTextConversation_Response_DataReader> AudioTextConversation_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AudioTextConversation_Response_DataReader> AudioTextConversation_Response_DataReader_out;


            class AudioTextConversation_Response_DataReaderView;

            typedef AudioTextConversation_Response_DataReaderView * AudioTextConversation_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AudioTextConversation_Response_DataReaderView> AudioTextConversation_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AudioTextConversation_Response_DataReaderView> AudioTextConversation_Response_DataReaderView_out;

            struct AudioTextConversation_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AudioTextConversation_Response_, struct AudioTextConversation_Response_Seq_uniq_> AudioTextConversation_Response_Seq;
            typedef DDS_DCPSSequence_var < AudioTextConversation_Response_Seq> AudioTextConversation_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AudioTextConversation_Response_Seq> AudioTextConversation_Response_Seq_out;

            class  AudioTextConversation_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AudioTextConversation_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AudioTextConversation_Response_TypeSupportInterface_var _var_type;

                static AudioTextConversation_Response_TypeSupportInterface_ptr _duplicate (AudioTextConversation_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AudioTextConversation_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AudioTextConversation_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AudioTextConversation_Response_TypeSupportInterface () {};
                ~AudioTextConversation_Response_TypeSupportInterface () {};
            private:
                AudioTextConversation_Response_TypeSupportInterface (const AudioTextConversation_Response_TypeSupportInterface &);
                AudioTextConversation_Response_TypeSupportInterface & operator = (const AudioTextConversation_Response_TypeSupportInterface &);
            };

            class  AudioTextConversation_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AudioTextConversation_Response_DataWriter_ptr _ptr_type;
                typedef AudioTextConversation_Response_DataWriter_var _var_type;

                static AudioTextConversation_Response_DataWriter_ptr _duplicate (AudioTextConversation_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AudioTextConversation_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AudioTextConversation_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AudioTextConversation_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AudioTextConversation_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AudioTextConversation_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AudioTextConversation_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AudioTextConversation_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AudioTextConversation_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AudioTextConversation_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AudioTextConversation_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AudioTextConversation_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AudioTextConversation_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AudioTextConversation_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AudioTextConversation_Response_& instance_data) = 0;

            protected:
                AudioTextConversation_Response_DataWriter () {};
                ~AudioTextConversation_Response_DataWriter () {};
            private:
                AudioTextConversation_Response_DataWriter (const AudioTextConversation_Response_DataWriter &);
                AudioTextConversation_Response_DataWriter & operator = (const AudioTextConversation_Response_DataWriter &);
            };

            class  AudioTextConversation_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AudioTextConversation_Response_DataReader_ptr _ptr_type;
                typedef AudioTextConversation_Response_DataReader_var _var_type;

                static AudioTextConversation_Response_DataReader_ptr _duplicate (AudioTextConversation_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AudioTextConversation_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AudioTextConversation_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AudioTextConversation_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AudioTextConversation_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AudioTextConversation_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AudioTextConversation_Response_& instance) = 0;

            protected:
                AudioTextConversation_Response_DataReader () {};
                ~AudioTextConversation_Response_DataReader () {};
            private:
                AudioTextConversation_Response_DataReader (const AudioTextConversation_Response_DataReader &);
                AudioTextConversation_Response_DataReader & operator = (const AudioTextConversation_Response_DataReader &);
            };

            class  AudioTextConversation_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AudioTextConversation_Response_DataReaderView_ptr _ptr_type;
                typedef AudioTextConversation_Response_DataReaderView_var _var_type;

                static AudioTextConversation_Response_DataReaderView_ptr _duplicate (AudioTextConversation_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AudioTextConversation_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AudioTextConversation_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AudioTextConversation_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AudioTextConversation_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AudioTextConversation_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AudioTextConversation_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AudioTextConversation_Response_& instance) = 0;

            protected:
                AudioTextConversation_Response_DataReaderView () {};
                ~AudioTextConversation_Response_DataReaderView () {};
            private:
                AudioTextConversation_Response_DataReaderView (const AudioTextConversation_Response_DataReaderView &);
                AudioTextConversation_Response_DataReaderView & operator = (const AudioTextConversation_Response_DataReaderView &);
            };
            class Sample_AudioTextConversation_Request_TypeSupportInterface;

            typedef Sample_AudioTextConversation_Request_TypeSupportInterface * Sample_AudioTextConversation_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AudioTextConversation_Request_TypeSupportInterface> Sample_AudioTextConversation_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AudioTextConversation_Request_TypeSupportInterface> Sample_AudioTextConversation_Request_TypeSupportInterface_out;


            class Sample_AudioTextConversation_Request_DataWriter;

            typedef Sample_AudioTextConversation_Request_DataWriter * Sample_AudioTextConversation_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AudioTextConversation_Request_DataWriter> Sample_AudioTextConversation_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AudioTextConversation_Request_DataWriter> Sample_AudioTextConversation_Request_DataWriter_out;


            class Sample_AudioTextConversation_Request_DataReader;

            typedef Sample_AudioTextConversation_Request_DataReader * Sample_AudioTextConversation_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AudioTextConversation_Request_DataReader> Sample_AudioTextConversation_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AudioTextConversation_Request_DataReader> Sample_AudioTextConversation_Request_DataReader_out;


            class Sample_AudioTextConversation_Request_DataReaderView;

            typedef Sample_AudioTextConversation_Request_DataReaderView * Sample_AudioTextConversation_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AudioTextConversation_Request_DataReaderView> Sample_AudioTextConversation_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AudioTextConversation_Request_DataReaderView> Sample_AudioTextConversation_Request_DataReaderView_out;

            struct Sample_AudioTextConversation_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AudioTextConversation_Request_, struct Sample_AudioTextConversation_Request_Seq_uniq_> Sample_AudioTextConversation_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AudioTextConversation_Request_Seq> Sample_AudioTextConversation_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AudioTextConversation_Request_Seq> Sample_AudioTextConversation_Request_Seq_out;

            class  Sample_AudioTextConversation_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AudioTextConversation_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AudioTextConversation_Request_TypeSupportInterface_var _var_type;

                static Sample_AudioTextConversation_Request_TypeSupportInterface_ptr _duplicate (Sample_AudioTextConversation_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AudioTextConversation_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AudioTextConversation_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AudioTextConversation_Request_TypeSupportInterface () {};
                ~Sample_AudioTextConversation_Request_TypeSupportInterface () {};
            private:
                Sample_AudioTextConversation_Request_TypeSupportInterface (const Sample_AudioTextConversation_Request_TypeSupportInterface &);
                Sample_AudioTextConversation_Request_TypeSupportInterface & operator = (const Sample_AudioTextConversation_Request_TypeSupportInterface &);
            };

            class  Sample_AudioTextConversation_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AudioTextConversation_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AudioTextConversation_Request_DataWriter_var _var_type;

                static Sample_AudioTextConversation_Request_DataWriter_ptr _duplicate (Sample_AudioTextConversation_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AudioTextConversation_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AudioTextConversation_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AudioTextConversation_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AudioTextConversation_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AudioTextConversation_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AudioTextConversation_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AudioTextConversation_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AudioTextConversation_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AudioTextConversation_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AudioTextConversation_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AudioTextConversation_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AudioTextConversation_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AudioTextConversation_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AudioTextConversation_Request_& instance_data) = 0;

            protected:
                Sample_AudioTextConversation_Request_DataWriter () {};
                ~Sample_AudioTextConversation_Request_DataWriter () {};
            private:
                Sample_AudioTextConversation_Request_DataWriter (const Sample_AudioTextConversation_Request_DataWriter &);
                Sample_AudioTextConversation_Request_DataWriter & operator = (const Sample_AudioTextConversation_Request_DataWriter &);
            };

            class  Sample_AudioTextConversation_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AudioTextConversation_Request_DataReader_ptr _ptr_type;
                typedef Sample_AudioTextConversation_Request_DataReader_var _var_type;

                static Sample_AudioTextConversation_Request_DataReader_ptr _duplicate (Sample_AudioTextConversation_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AudioTextConversation_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AudioTextConversation_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AudioTextConversation_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AudioTextConversation_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AudioTextConversation_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AudioTextConversation_Request_& instance) = 0;

            protected:
                Sample_AudioTextConversation_Request_DataReader () {};
                ~Sample_AudioTextConversation_Request_DataReader () {};
            private:
                Sample_AudioTextConversation_Request_DataReader (const Sample_AudioTextConversation_Request_DataReader &);
                Sample_AudioTextConversation_Request_DataReader & operator = (const Sample_AudioTextConversation_Request_DataReader &);
            };

            class  Sample_AudioTextConversation_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AudioTextConversation_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AudioTextConversation_Request_DataReaderView_var _var_type;

                static Sample_AudioTextConversation_Request_DataReaderView_ptr _duplicate (Sample_AudioTextConversation_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AudioTextConversation_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AudioTextConversation_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AudioTextConversation_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AudioTextConversation_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AudioTextConversation_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AudioTextConversation_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AudioTextConversation_Request_& instance) = 0;

            protected:
                Sample_AudioTextConversation_Request_DataReaderView () {};
                ~Sample_AudioTextConversation_Request_DataReaderView () {};
            private:
                Sample_AudioTextConversation_Request_DataReaderView (const Sample_AudioTextConversation_Request_DataReaderView &);
                Sample_AudioTextConversation_Request_DataReaderView & operator = (const Sample_AudioTextConversation_Request_DataReaderView &);
            };
            class Sample_AudioTextConversation_Response_TypeSupportInterface;

            typedef Sample_AudioTextConversation_Response_TypeSupportInterface * Sample_AudioTextConversation_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AudioTextConversation_Response_TypeSupportInterface> Sample_AudioTextConversation_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AudioTextConversation_Response_TypeSupportInterface> Sample_AudioTextConversation_Response_TypeSupportInterface_out;


            class Sample_AudioTextConversation_Response_DataWriter;

            typedef Sample_AudioTextConversation_Response_DataWriter * Sample_AudioTextConversation_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AudioTextConversation_Response_DataWriter> Sample_AudioTextConversation_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AudioTextConversation_Response_DataWriter> Sample_AudioTextConversation_Response_DataWriter_out;


            class Sample_AudioTextConversation_Response_DataReader;

            typedef Sample_AudioTextConversation_Response_DataReader * Sample_AudioTextConversation_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AudioTextConversation_Response_DataReader> Sample_AudioTextConversation_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AudioTextConversation_Response_DataReader> Sample_AudioTextConversation_Response_DataReader_out;


            class Sample_AudioTextConversation_Response_DataReaderView;

            typedef Sample_AudioTextConversation_Response_DataReaderView * Sample_AudioTextConversation_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AudioTextConversation_Response_DataReaderView> Sample_AudioTextConversation_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AudioTextConversation_Response_DataReaderView> Sample_AudioTextConversation_Response_DataReaderView_out;

            struct Sample_AudioTextConversation_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_AudioTextConversation_Response_, struct Sample_AudioTextConversation_Response_Seq_uniq_> Sample_AudioTextConversation_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AudioTextConversation_Response_Seq> Sample_AudioTextConversation_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AudioTextConversation_Response_Seq> Sample_AudioTextConversation_Response_Seq_out;

            class  Sample_AudioTextConversation_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AudioTextConversation_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AudioTextConversation_Response_TypeSupportInterface_var _var_type;

                static Sample_AudioTextConversation_Response_TypeSupportInterface_ptr _duplicate (Sample_AudioTextConversation_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AudioTextConversation_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AudioTextConversation_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AudioTextConversation_Response_TypeSupportInterface () {};
                ~Sample_AudioTextConversation_Response_TypeSupportInterface () {};
            private:
                Sample_AudioTextConversation_Response_TypeSupportInterface (const Sample_AudioTextConversation_Response_TypeSupportInterface &);
                Sample_AudioTextConversation_Response_TypeSupportInterface & operator = (const Sample_AudioTextConversation_Response_TypeSupportInterface &);
            };

            class  Sample_AudioTextConversation_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AudioTextConversation_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AudioTextConversation_Response_DataWriter_var _var_type;

                static Sample_AudioTextConversation_Response_DataWriter_ptr _duplicate (Sample_AudioTextConversation_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AudioTextConversation_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AudioTextConversation_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AudioTextConversation_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AudioTextConversation_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AudioTextConversation_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AudioTextConversation_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AudioTextConversation_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AudioTextConversation_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AudioTextConversation_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AudioTextConversation_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AudioTextConversation_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AudioTextConversation_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AudioTextConversation_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AudioTextConversation_Response_& instance_data) = 0;

            protected:
                Sample_AudioTextConversation_Response_DataWriter () {};
                ~Sample_AudioTextConversation_Response_DataWriter () {};
            private:
                Sample_AudioTextConversation_Response_DataWriter (const Sample_AudioTextConversation_Response_DataWriter &);
                Sample_AudioTextConversation_Response_DataWriter & operator = (const Sample_AudioTextConversation_Response_DataWriter &);
            };

            class  Sample_AudioTextConversation_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AudioTextConversation_Response_DataReader_ptr _ptr_type;
                typedef Sample_AudioTextConversation_Response_DataReader_var _var_type;

                static Sample_AudioTextConversation_Response_DataReader_ptr _duplicate (Sample_AudioTextConversation_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AudioTextConversation_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AudioTextConversation_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AudioTextConversation_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AudioTextConversation_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AudioTextConversation_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AudioTextConversation_Response_& instance) = 0;

            protected:
                Sample_AudioTextConversation_Response_DataReader () {};
                ~Sample_AudioTextConversation_Response_DataReader () {};
            private:
                Sample_AudioTextConversation_Response_DataReader (const Sample_AudioTextConversation_Response_DataReader &);
                Sample_AudioTextConversation_Response_DataReader & operator = (const Sample_AudioTextConversation_Response_DataReader &);
            };

            class  Sample_AudioTextConversation_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AudioTextConversation_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AudioTextConversation_Response_DataReaderView_var _var_type;

                static Sample_AudioTextConversation_Response_DataReaderView_ptr _duplicate (Sample_AudioTextConversation_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AudioTextConversation_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AudioTextConversation_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AudioTextConversation_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AudioTextConversation_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AudioTextConversation_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AudioTextConversation_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AudioTextConversation_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AudioTextConversation_Response_& instance) = 0;

            protected:
                Sample_AudioTextConversation_Response_DataReaderView () {};
                ~Sample_AudioTextConversation_Response_DataReaderView () {};
            private:
                Sample_AudioTextConversation_Response_DataReaderView (const Sample_AudioTextConversation_Response_DataReaderView &);
                Sample_AudioTextConversation_Response_DataReaderView & operator = (const Sample_AudioTextConversation_Response_DataReaderView &);
            };
        }

    }

}

#endif
